package beans;

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import beans.*;

public class FrameBean extends Frame {

  private Vector sistema;

  TextField textFieldTexto = new TextField();
  TextField textFieldPosicao = new TextField();
  Label label1 = new Label();
  Label label2 = new Label();
//  PainelDeControle painelDeControle1 = new PainelDeControle();
  PainelDeControle painelDeControle = new PainelDeControle();

  //Construct the frame

  public FrameBean() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    sistema = new Vector();
    try  {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
//Component initialization

  private void jbInit() throws Exception  {
    this.setLayout(null);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Java Beans");
    textFieldTexto.setBounds(new Rectangle(23, 72, 166, 26));
    textFieldPosicao.setBounds(new Rectangle(259, 72, 47, 25));
    label1.setBounds(new Rectangle(23, 48, 126, 22));
    label1.setText("Texto");
    label2.setBounds(new Rectangle(260, 48, 49, 22));
    label2.setText("Posio");
    painelDeControle.setBounds(new Rectangle(22, 112, 324, 106));
    painelDeControle.addPainelDeControleListener(new FrameBean_painelDeControle_painelDeControleAdapter(this));
    this.add(textFieldTexto, null);
    this.add(textFieldPosicao, null);
    this.add(label1, null);
    this.add(label2, null);
    this.add(painelDeControle, null);
  }
//Overriden so we can exit on System Close

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void painelDeControle_botaoConsultarPressionado(PainelDeControleEvent e) {
    try {
      int pos = (new Integer( textFieldPosicao.getText() )).intValue() - 1;
      textFieldTexto.setText( (String) sistema.elementAt(pos) );
      painelDeControle.setMensagem("Mostrando texto na posio " + (pos + 1));
    } catch (ArrayIndexOutOfBoundsException ex) {
      painelDeControle.setMensagem("Posio invlida ou inexistente!");
    } catch (NumberFormatException  nfe) {
      painelDeControle.setMensagem("Posio invlida!");
    }
  }

  void painelDeControle_botaoInserirPressionado(PainelDeControleEvent e) {
    String texto = textFieldTexto.getText();
    painelDeControle.setMensagem(null);
    sistema.addElement( texto );
    painelDeControle.setMensagem("Texto \"" + texto + "\" inserido na posio " + sistema.size());
  }

  void painelDeControle_botaoLimparPressionado(PainelDeControleEvent e) {
    painelDeControle.setMensagem(null);
    textFieldTexto.setText(null);
    textFieldPosicao.setText(null);
  }
}

class FrameBean_painelDeControle_painelDeControleAdapter implements beans.PainelDeControleListener{
  FrameBean adaptee;

  
  FrameBean_painelDeControle_painelDeControleAdapter(FrameBean adaptee) {
    this.adaptee = adaptee;
  }

  public void botaoInserirPressionado(PainelDeControleEvent e) {
    adaptee.painelDeControle_botaoInserirPressionado(e);
  }

  public void botaoConsultarPressionado(PainelDeControleEvent e) {
    adaptee.painelDeControle_botaoConsultarPressionado(e);
  }

  public void botaoLimparPressionado(PainelDeControleEvent e) {
    adaptee.painelDeControle_botaoLimparPressionado(e);
  }
}


