
//Title:        Exemplo de Java Beans do Curso de Especializao
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Eduardo Aranha
//Company:      DI - UFPE
//Description:  Este exemplo dever ser seguido na aula de laboratrio de Java Beans.
//Abaixo segue o roteiro a ser seguido.

package beans;

import java.awt.*;
import java.io.*;
import beans.*;
import java.util.*;
import java.awt.event.*;

public class PainelDeControle extends Panel implements Serializable{
  Button botaoInserir = new Button();
  Label labelMensagem = new Label();
  Button botaoLimpar = new Button();
  Button botaoConsultar = new Button();
  private transient Vector painelDeControleListeners;

  
  public PainelDeControle() {
    try  {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    botaoInserir.setBounds(new Rectangle(10, 11, 72, 38));
    botaoInserir.setLabel("Inserir");
    botaoInserir.addActionListener(new PainelDeControle_botaoInserir_actionAdapter(this));
    labelMensagem.setBounds(new Rectangle(11, 61, 251, 24));
    botaoLimpar.setLabel("Limpar");
    botaoLimpar.addActionListener(new PainelDeControle_botaoLimpar_actionAdapter(this));
    botaoConsultar.setLabel("Consultar");
    botaoConsultar.addActionListener(new PainelDeControle_botaoConsultar_actionAdapter(this));
    botaoConsultar.setBounds(new Rectangle(87, 11, 78, 38));
    botaoLimpar.setBounds(new Rectangle(170, 10, 69, 39));
    this.setLayout(null);
    this.add(botaoInserir, null);
    this.add(labelMensagem, null);
    this.add(botaoLimpar, null);
    this.add(botaoConsultar, null);
  }

  void writeObject(ObjectOutputStream oos) throws IOException {
    oos.defaultWriteObject();
  }

  void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException {
    ois.defaultReadObject();
  }

  public void setMensagem(String newMensagem) {
    labelMensagem.setText(newMensagem);
  }

  public String getMensagem() {
    return labelMensagem.getText();
  }

  public void setInserirHabilitado(boolean newInserirHabilitado) {
    botaoInserir.setEnabled(newInserirHabilitado);
  }

  public boolean isInserirHabilitado() {
    return botaoInserir.isEnabled();
  }

  public void setConsultarHabilitado(boolean newConsultarHabilitado) {
    botaoConsultar.setEnabled(newConsultarHabilitado);
  }

  public boolean isConsultarHabilitado() {
    return botaoConsultar.isEnabled();
  }

  public void setLimparHabilitado(boolean newLimparHabilitado) {
    botaoLimpar.setEnabled(newLimparHabilitado);
  }

  public boolean isLimparHabilitado() {
    return botaoLimpar.isEnabled();
  }

  public synchronized void removePainelDeControleListener(PainelDeControleListener l) {
    if (painelDeControleListeners != null && painelDeControleListeners.contains(l)) {
      Vector v = (Vector) painelDeControleListeners.clone();
      v.removeElement(l);
      painelDeControleListeners = v;
    }
  }

  public synchronized void addPainelDeControleListener(PainelDeControleListener l) {
    Vector v = painelDeControleListeners == null ? new Vector(2) : (Vector) painelDeControleListeners.clone();
    if (!v.contains(l)) {
      v.addElement(l);
      painelDeControleListeners = v;
    }
  }

  protected void fireBotaoInserirPressionado(PainelDeControleEvent e) {
    if (painelDeControleListeners != null) {
      Vector listeners = painelDeControleListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
        ((PainelDeControleListener) listeners.elementAt(i)).botaoInserirPressionado(e);
    }
  }

  protected void fireBotaoConsultarPressionado(PainelDeControleEvent e) {
    if (painelDeControleListeners != null) {
      Vector listeners = painelDeControleListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
        ((PainelDeControleListener) listeners.elementAt(i)).botaoConsultarPressionado(e);
    }
  }

  protected void fireBotaoLimparPressionado(PainelDeControleEvent e) {
    if (painelDeControleListeners != null) {
      Vector listeners = painelDeControleListeners;
      int count = listeners.size();
      for (int i = 0; i < count; i++)
        ((PainelDeControleListener) listeners.elementAt(i)).botaoLimparPressionado(e);
    }
  }

  void botaoInserir_actionPerformed(ActionEvent e) {
    fireBotaoInserirPressionado(new PainelDeControleEvent(this));
  }

  void botaoConsultar_actionPerformed(ActionEvent e) {
    fireBotaoConsultarPressionado(new PainelDeControleEvent(this));
  }

  void botaoLimpar_actionPerformed(ActionEvent e) {
    fireBotaoLimparPressionado(new PainelDeControleEvent(this));
  }
}

class PainelDeControle_botaoInserir_actionAdapter implements java.awt.event.ActionListener{
  PainelDeControle adaptee;

  
  PainelDeControle_botaoInserir_actionAdapter(PainelDeControle adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.botaoInserir_actionPerformed(e);
  }
}


class PainelDeControle_botaoConsultar_actionAdapter implements java.awt.event.ActionListener {
  PainelDeControle adaptee;

  
  PainelDeControle_botaoConsultar_actionAdapter(PainelDeControle adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.botaoConsultar_actionPerformed(e);
  }
}

class PainelDeControle_botaoLimpar_actionAdapter implements java.awt.event.ActionListener {
  PainelDeControle adaptee;

  
  PainelDeControle_botaoLimpar_actionAdapter(PainelDeControle adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.botaoLimpar_actionPerformed(e);
  }
}


