
//Title:        Exemplo de Java Beans do Curso de Especializao
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Eduardo Aranha
//Company:      DI - UFPE
//Description:  Este exemplo dever ser seguido na aula de laboratrio de Java Beans.
//Abaixo segue o roteiro a ser seguido.

package beans;

import java.beans.*;
import editorTextArea.TextoEditor;

public class PainelDeControleBeanInfo extends SimpleBeanInfo {
  Class beanClass = PainelDeControle.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  
  public PainelDeControleBeanInfo() {
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    try  {
      PropertyDescriptor _consultarHabilitado = new PropertyDescriptor("consultarHabilitado", beanClass, "isConsultarHabilitado", "setConsultarHabilitado");
      _consultarHabilitado.setDisplayName("consultarHabilitado");
      _consultarHabilitado.setShortDescription("Indica se o boto consultar est habilitado");

      PropertyDescriptor _inserirHabilitado = new PropertyDescriptor("inserirHabilitado", beanClass, "isInserirHabilitado", "setInserirHabilitado");
      _inserirHabilitado.setDisplayName("inserirHabilitado");
      _inserirHabilitado.setShortDescription("Indica se o boto inserir est habilitado");
      
      PropertyDescriptor _limparHabilitado = new PropertyDescriptor("limparHabilitado", beanClass, "isLimparHabilitado", "setLimparHabilitado");
      _limparHabilitado.setDisplayName("limparHabilitado");
      _limparHabilitado.setShortDescription("Indica se o boto de Limpar est habilitado");
      
      PropertyDescriptor _mensagem = new PropertyDescriptor("mensagem", beanClass, "getMensagem", "setMensagem");
      _mensagem.setDisplayName("mensagem");
      _mensagem.setShortDescription("Mensagem a ser mostrada no visor do controle");
      _mensagem.setPropertyEditorClass(editorTextArea.TextoEditor.class);

      PropertyDescriptor[] pds = new PropertyDescriptor[] {
        _consultarHabilitado,
        _inserirHabilitado,
        _limparHabilitado,
        _mensagem,
      };
      return pds;
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind) {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
      return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
      return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
      return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
      return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
    }
    return null;
  }

  public BeanInfo[] getAdditionalBeanInfo() {
    Class superclass = beanClass.getSuperclass();
    try  {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch (IntrospectionException ex) {
      ex.printStackTrace();
      return null;
    }
  }
}



 