/**
 * @(#)TextoEditor.java
 * Autor: Kellen Christine
 * Data: Nov 01 99
 * Copyright (c) 1997-1999 Departamento de Informtica - UFPE
 */

/**
 * A classe <code>TextoEditor</code> define um editor de propriedade
 * personalizado para uma propriedade que  um texto(nao apenas um String, pois
 * pequeno pode haver quebra de linha).  um editor bem simples que serve apenas
 * como um exemplo, pois a propriedade text de um textArea qualquer tambem faz a
 * mesma coisa. Ela define os metodos para modificar e retornar o valor da
 * propriedade e tem como atributo um textAreaEditorPanel (panel que aparecera
 * na janela do editor quando ele for chamado).
 * @author  Kellen Christine
 * @version 1.0, 01/11/99
 * @since   JDK1.0
 */

package editorTextArea;

import java.awt.*;
import java.beans.*;

public class TextoEditor extends PropertyEditorSupport {
  private TextoEditorPanel editor;
  String value;

  public TextoEditor() {
    editor = new TextoEditorPanel(this);
  }

  public boolean supportsCustomEditor() {
    return true;
  }

  public Component getCustomEditor() {
    if (editor == null) {
      editor = new TextoEditorPanel(this);
    }
    return editor;
  }

  public String getJavaInitializationString() {
//    return "";
    return this.stringParaOCodigo(value);
  }


  private String stringParaOCodigo(String str) {
    String s = "\"";
    char c;

    for( int i = 0; i < str.length(); i++ )  {
      c = str.charAt(i);
      if( c != '\n' )  {
        if( c == '\\' )
          s = s + "\\\\";
        else
          s = s + c;
      }
      else
        s = s + "\\n";
    }
    s = s + "\"";
    return s;
  }


  public Object getValue() {
    if( editor != null )
      value = editor.textArea.getText();
    return value;
  }


  public void setValue(Object v)  {
    value = (String) v;
    if (editor != null)
      editor.textArea.setText(value);
  }

  public String getAsText()  {
    return value;
  }

  public void setAsText(String text) {
    value = text;
  }

}

